//Driver Station map
//Values may change frequently
#ifndef DSMAP_H
#define DSMAP_H

//Joystick Ports
#define DS_JOY_PORT_LEFT			1
#define DS_JOY_PORT_RIGHT			2
#define DS_JOY_PORT_AUX				3
#define DS_JOY_PORT_EMULATED		4

//Joystick Buttons
#define DS_JOYBTN_TURBO				1
#define DS_JOYBTN_SLOW				2
#define DS_JOYBTN_REVERSE			3
#define DS_JOYBTN_DEBUG_SHOOTER		6	// left joystick
#define DS_JOYBTN_DEBUG_CLIMBER		7	// left joystick
#define DS_JOYBTN_DEBUG_FLAGS		8	// left joystick
#define DS_JOYBTN_DEBUG_TARGET		10	// left joystick
#define DS_JOYBTN_DEBUG_DRIVE		11	// left joystick
// fun buttons
#define DS_JOYBTN_FUN_1				6	// right joystick
#define DS_JOYBTN_FUN_2				7	// right joystick
//Aux Joystick Buttons
#define DS_SHOOT_DISK				1
#define DS_FEED_MODE				2
#define DS_INDEX_DISK				3   //manually control index motor
#define DS_TILT_CAMERA_DOWN			4
#define DS_TILT_CAMERA_UP			5
#define DS_DEPLOY					6
#define DS_CLIMB					7   //non-broken mode
#define DS_CONTROL_LIGHT_RING		8 
#define DS_CLIMB_PREDEP_OVERRIDE    10 // override the predeploy
//restriction on shuttle motion
//in climber manual mode


// Aux and Right joystick
#define DS_DUMPER_DEPLOY			11

//Emulated Joystick Inputs 
//Digital Buttons
#define DS_BROKEN_STORAGE			1   //manually drop the disk into the storage
#define DS_BROKEN_SHOOTER			2   //allows manual power input to shoot
#define DS_BROKEN_LIFT				3   //allows for manual climbing (if dead center position)
#define DS_BROKEN_SHOOTER_STORAGE	4    //allows for manual shooting
#define DS_BROKEN_AUTO_CLIMB		5   //allows manual allinment and then manual climbing
#define DS_BROKEN_ARM_LIMITS				6   //arms at constant speed
#define DS_BROKEN_CLIMB_COMPLETELY	7   //no climbing allowed at all; motors, servers, actuators are broken
#define DS_BROKEN_SPEED_OVERRIDE	8	//allows drivers to keep shooter wheel always on
// SmartDashboard names
#define SMART_SHOOTER_POWER			"Shooterpower"
#define SMART_ANGLE_ACTUAL			"Actualangle"
#define SMART_ANGLE_DESIRED			"Desiredangle"
#define SMART_NUM_DISCS				"Startdisks"
#define SMART_AUTO_DELAY			"Delay"
#define SMART_AUTO_MODE				"Automode"
#define SMART_ACTUAL_DISCS			"ActualDiscs"
#define SMART_SHOOTER_DIR_LIGHT		"ShooterDirectionLight"
#define SMART_CLIMBER_DIR_LIGHT		"ClimberDirectionLight"
#define SMART_FEED_GREEN_LIGHT		"FeedGreenLight"
#define SMART_FEED_RED_LIGHT		"FeedRedLight"
#define SMART_DISC1_GREEN_LIGHT		"Disc1GreenLight"
#define SMART_DISC1_RED_LIGHT		"Disc1RedLight"
#define SMART_DISC2_GREEN_LIGHT		"Disc2GreenLight"
#define SMART_DISC2_RED_LIGHT		"Disc2RedLight"
#define SMART_DISC3_GREEN_LIGHT		"Disc3GreenLight"
#define SMART_DISC3_RED_LIGHT		"Disc3RedLight"
#define SMART_DISC4_GREEN_LIGHT		"Disc4GreenLight"
#define SMART_DISC4_RED_LIGHT		"Disc4RedLight"

// this includes the null terminator
#define DEBUG_LINE_LENGTH 			22

#endif //DSMAP_H
