#ifndef IOMAP_H
#define IOMAP_H 1// I/O port and pin assignments
//////////////  CAN Jaguar Numbers  ///////////////////
//#define (FACTORY DEFAULT, DON'T USE)		(1)
#define	CANID_DRIVETRAIN_LEFT				(2)		
#define	CANID_DRIVETRAIN_LEFT_2ND			(3)		// optional 2nd drive - left wheel
#define CANID_DRIVETRAIN_RIGHT				(4)
#define CANID_DRIVETRAIN_RIGHT_2ND			(5)		// optional 2nd driver - right wheel
//#define	CANID_CLIMBER_LEFT					(6)		// Climber - Left Drive
#define	CANID_CLIMBER_RIGHT					(7)		// Climber - Right Drive
#define CANID_SHOOTER_WHEEL_MOTOR			(8)
#define CANID_SHOOTER_TILT_MOTOR			(9)
#define CANID_SHOOTER_CAROUSEL_MOTOR		(10)

////////////// Digital Inputs //////////////////////
#define DIG_DRIVETRAIN_LEFT_ENCODER_A		(1)
#define DIG_CLIMB_HOOK_LEFT_SIDE_ENGAGED	(2)
#define DIG_DRIVETRAIN_RIGHT_ENCODER_A		(3)
#define DIG_CLIMB_HOOK_RIGHT_SIDE_ENGAGED	(4)
#define DIG_SHOOTER_WHEEL_ENCODER_A			(5)
#define DIG_FIXED_CLIMB_LH_ENGAGED			(6)
#define DIG_FIXED_CLIMB_RH_ENGAGED			(7) 	// both right and left 
#define DIG_CLIMB_SHUTTLE_DEPLOY_POSITION	(8)		// initial climb alignment
#define DIG_CLIMB_SHUTTLE_MAX_EXTENSION 	(9) 	// top
#define DIG_CLIMB_SHUTTLE_MAX_RETRACTION 	(10)	// bottom
#define DIG_SHOOTER_DISC_1_PRESENT			(11)	// disc detected in feeder slot
#define DIG_SHOOTER_FEED_ALIGN				(12)
#define DIG_SHOOTER_LOADER_ALIGN 			(13)	// aligned to allow disc to fall into shooteer
#define DIG_SHOOTER_READY_TO_SHOOT			(14)

/////////////// Digital Outputs //////////////////////

///////////////// PWM Outputs ///////////////////
#define PWM_CAMERA_TILT_SERVO				(1)
// No longer exists; but kept reserved
//#define PWM_CLIMBER_DEPLOY_LH_SERVO			(2)
#define PWM_CLIMBER_DEPLOY_RH_SERVO			(3)
#define PWM_SHOOTER_LOAD_BLOCKER_SEVO		(4)
#define PWM_SHOOTER_LOAD_PUSHER_SERVO		(5)
#define PWM_DUMPER_RELEASE_SERVO			(6)

///////////////// Relay Outputs //////////////////
#define RELAY_CAMERA_RING_LIGHT				(1)

///////////////// Analog Inputs ////////////////////
#define ANA_DRIVETRAIN_GYRO					(1)
//#define ANA_ROBOT_VEE_ALIGN_SENSOR			(2)
//#define ANA_OPTIONAL_DISC_2_PRESENT			(3)		// optional sensor not currently in design
//#define ANA_OPTIONAL_DISC_3_PRESENT 		(4)		// optional sensor not currently in design 
#define ANA_CLIMB_LIFT_ARMS_POT				(5)		// use for position/speed control
#define ANA_LEFT_SHOOTER_TILT_SENSOR		(6)		// potentiometer
//#define ANA_RIGHT_SHOOTER_TILT_SENSOR		(7)		// potentiometer
#define ANA_BATTERY_VOLT_INPUT				(8)		// reserved, do ot use for any other devic
///////////////// I2C Registers ////////////////////
// I2C_NUMBER_BANKS is the total # of banks we are using
// I2C_*_BANK is the index into I2C_BANK_ADDRESS_INIT for that light
// I2C_*_GP is the bit within the bank
#define I2C_NUMBER_BANKS					2
#define I2C_BANK_ADDRESS_INIT				{ (UINT8)0x4F, (UINT8)0x41 }
#define I2C_DISC1GREEN_BANK					0
#define I2C_DISC1GREEN_GP					0x01 // GP0 = disc 1 present green
#define I2C_DISC1RED_BANK					0
#define I2C_DISC1RED_GP						0x02 // GP1 = disc 1 present red
#define I2C_DISC2GREEN_BANK					0
#define I2C_DISC2GREEN_GP					0x04 // GP2 = disc 2 present green
#define I2C_DISC2RED_BANK					0
#define I2C_DISC2RED_GP						0x08 // GP3 = disc 2 present red
#define I2C_DISC3GREEN_BANK					0
#define I2C_DISC3GREEN_GP					0x10 // GP4 = disc 3 present green
#define I2C_DISC3RED_BANK					0
#define I2C_DISC3RED_GP						0x20 // GP5 = disc 3 present red
#define I2C_DISC4GREEN_BANK					0
#define I2C_DISC4GREEN_GP					0x40 // GP6 = disc 4 present green
#define I2C_DISC4RED_BANK					0
#define I2C_DISC4RED_GP						0x80 // GP7 = disc 4 present red
#define I2C_FEEDGREEN_BANK					1
#define I2C_FEEDGREEN_GP					0x01 // GP0 = OK to feed disc on green
#define I2C_FEEDRED_BANK					1
#define I2C_FEEDRED_GP						0x02 // GP1 = NOT OK to feed disc on red
#define I2C_SHOOTERDIRECTION_BANK			1

// NOTE: on current, Boston Day 2 i2c board, 1-0x10 does not work
// old #define I2C_SHOOTERDIRECTION_GP				0x04 // GP2 = robot forward indicator
#define I2C_SHOOTERDIRECTION_GP				0x10 // GP2 = robot forward indicator
#define I2C_CLIMBERDIRECTION_BANK			1
#define I2C_CLIMBERDIRECTION_GP				0x08 // GP3 = robot rearward indicator
#define I2C_SHOOTERLIGHT_BANK				1

// old #define I2C_SHOOTERLIGHT_GP					0x10 // GP4 = shooter aiming light
#define I2C_SHOOTERLIGHT_GP					0x04 // GP4 = shooter aiming light

#endif

