#include "MonoEncoder.h"

MonoEncoder::MonoEncoder(int channel, double max_rps) {
	count = new Counter(channel);

	count->Start();
	lastTime = Timer::GetPPCTimestamp();
	totalCount = 0;
	lastSpeed = 0;
	maxRPS = max_rps;
}

MonoEncoder::~MonoEncoder() {
	delete count;
}

int MonoEncoder::getTotalCount() {
	return count->Get();
}

double MonoEncoder::getLastSpeed() {
	return lastSpeed;
}

double MonoEncoder::getRevPerSec() {
	return lastSpeed * maxRPS;
}

double MonoEncoder::PIDGet() {
	double period = count->GetPeriod();
	lastSpeed = 1 / (period * TICKS_PER_REV * maxRPS);
	return lastSpeed;
}
