#ifndef _AUTO_H_
#define _AUTO_H_

#include "WPIlib.h"
#include "WeejusDrive.h"
#include "WeejusShooter.h"

// Mode 1 (Back corner -> High Goal)
//
// History!:
// FLR -.517, .57 // inconsistent??
// BR1 - .525, .57 // a bit too high; first OK, second/third bad suspect shooter not @speed when 1st disk is shot
// RB2 -.3, .7 // overshot on RB1 by 3ft
// BR2 -1, .6 // seems to work... Previous ones failed due to very low angle(pot) derivatives
// BR3 -.65, .57 first disk barely made, 2nd/3rd 3in too high
// BR4 -.79, .57 1st disc, 6" lower, 2nd/3rd disc 2" low
// *BR5 -.72, .57 this was fine for high, mid goal 3/4" too high
// pre-champs - change power to .58 to match BR8; slightly too high
// C1  -.75, 0.58
// C2 -0.77 because 1st disc is too high (we change angle after 1st disc)

// Home1 -0.99 0.65 // seems to work
// -0.99, 0.64 slightly too high;

// darn batteries...

//-.77, .58
#define MODE1_SHOOT_ANGLE		-0.93f // angle slider position
#define MODE1_SHOOT_POWER		0.63f // power slider position
// Mode 2 (Back corner -> Med Goal)
// uses same state machine as mode 1
//
// History!:
// BR6 -.90, .57 medium goal, barely above base
// BR7 -.85, .57 roughly on center, power insufficient (chain kickback)
// *BR8 -.85, .58 recommended medium goal
#define MODE2_SHOOT_ANGLE		-0.85f // angle slider position
#define MODE2_SHOOT_POWER		0.58f// power slider position
// Mode 3 (Front center -> High Goal)
// uses same state machine as mode 1
//CH1 -.7, .45 // this went about 0.7 m too low
#define MODE3_SHOOT_ANGLE		-0.35f // angle slider position
#define MODE3_SHOOT_POWER		0.58f	// power slider position
class WeejusAuto {
public:
	WeejusAuto();
	~WeejusAuto();

	// gets a pointer to this class
	static WeejusAuto* getInstance();

	// initialize auto (call it once)
	// returns TRUE if running any mode
	bool initialize(int mode, int delay);

	// process all auto steps (call it for every loop in autonomous)
	bool process();

	// call when autonomous ends
	void endAuto(bool endedOK);

private:
	static WeejusAuto* _theAuto;

	typedef enum AUTO_STATE_MAIN {
		autoDelay, autoDelayCheck, autoRun, autoRunCheck, autoFeed, autoEnded
	};
	typedef enum AUTO_STATE_MODE1 {
		mode1Lower, mode1LowerCheck, mode1Shoot, mode1ShootCheck, mode1Ended
	};
	//	typedef enum AUTO_STATE_MODE2 { mode2Drive, mode2DriveCheck, mode2TurnCheck, mode2ShootCheck, mode2Ended};

	bool runMode1();
	//bool runMode2();


	//void updateAngle(float desiredAngle);
	// checks if we are off course
	//bool checkCourse();

	AUTO_STATE_MAIN _autoStateMain;
	AUTO_STATE_MODE1 _autoStateMode1;
	//	AUTO_STATE_MODE2 _autoStateMode2;

	WeejusShooter *_shooter;
	WeejusDrive *_drive;

	double begin_time;
	double begin_time_shoot;
	int _mode;
	float _delay;

	int _discToLower;

	float _autoSpeedMode1;
	float _autoAngleMode1;

	//to make sure we are still driving on course.
	float minAngle; // min angle we need to stay within
	float maxAngle; // max angle we need to stay within
};
#endif 
