#ifndef WEEJUSPOTENCODER_H_
#define WEEJUSPOTENCODER_H_

#include "WPILib.h"
//#include "semLib.h"
//#include "Controller.h"

/* 1TBS! Long live 1TBS! */

/*
 * Turns a pot into a speed PIDOut. 
 * There is a simple window-filter
 * Model it on PIDController
 * This gets its own thread
 * 
 */
class WeejusPotEncoder: public PIDSource, public Controller {
public:
	WeejusPotEncoder(UINT32 channel, float max_speed);
	~WeejusPotEncoder(void);// this may overwrite the old deleting, from PIDSource

	double PIDGet(void);
	double ReadVelocity(void);
	double GetPos(void);

	void Enable(void);
	void Disable(void);
private:
	// updates every 20 ms
	static const float pot_update_period = 0.020; // 12.5 msec;

	static void CallUpdateVelocity(void *controller);

	void UpdateVelocity();

	AnalogChannel* m_pot;

	// these need to be doubles, to avoid precision loss
	double m_last_position;
	double m_last_time;
	double m_velocity;
	double m_max_speed;

	SEM_ID m_semaphore;
	Notifier* m_controlLoop;
};

#endif /*WEEJUSPOTENCODER_H_*/
